"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var apollo_link_1 = require("apollo-link");
var OptimisticLink = (function (_super) {
    __extends(OptimisticLink, _super);
    function OptimisticLink() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OptimisticLink.prototype.request = function (operation, forward) {
        if (!operation.getContext().optimisticResponse) {
            return forward(operation);
        }
        return new apollo_link_1.Observable(function (observer) {
            setTimeout(function () { return observer.next(operation.getContext().optimisticResponse); }, 0);
            var subscription = forward(operation).subscribe({
                next: observer.next.bind(observer),
                error: observer.error.bind(observer),
                complete: observer.complete.bind(observer)
            });
            return function () {
                subscription.unsubscribe();
            };
        });
    };
    return OptimisticLink;
}(apollo_link_1.ApolloLink));
exports["default"] = OptimisticLink;
//# sourceMappingURL=OptimisticLink.js.map