import { ApolloLink, Operation, Observable } from 'apollo-link';
import { ExecutionResult } from 'graphql';
export declare class TestLink extends ApolloLink {
    operations: Operation[];
    constructor();
    request(operation: Operation): Observable<{}>;
}
export interface ObservableValue {
    value?: ExecutionResult | Error;
    delay?: number;
    type: 'next' | 'error' | 'complete';
}
export interface Unsubscribable {
    unsubscribe: () => void;
}
export declare const assertObservableSequence: (observable: Observable<ExecutionResult>, sequence: ObservableValue[], initializer?: (sub: Unsubscribable) => void) => Promise<boolean | Error>;
